function policy = opt_policy(iter_steps,k0,k1, V, x, y, max_coord,alpha_value, beta_value, sigma, phi, A_prod, c0, c_use);
% function policy = opt_policy(iter_steps,k0,k1, V, x, y, max_coord,alpha_value, beta_value, sigma, phi, A_prod, c0, c_use);
%
% If c_use = 1, c0 is used as initial reference consumption 
%   (otherwise c0 = productionF(A_prod,k0) - k1)
%
% Author: Klaus Reiner Schenk-Hopp (klaus@schenk-hoppe.net)
% First version: January 20, 2005.
% Last update: August 18, 2010.

k1start = k0;
k2start = k1;

%%%% Find closest point on grid
k1x = round(k1start/x(max_coord)*max_coord+0.5);
k2x = round(k2start/x(max_coord)*max_coord+0.5);
if ( k1x > max_coord),
   k1x = max_coord;
end
if ( k2x > max_coord),
   k2x = max_coord;
end

policy(1,:) = [k1x k2x];

for i = 1:iter_steps,

     xt = x(policy(i,1));
     yt = y(policy(i,2));

        optix = policy(i,2);
        optiy = -1; 
        maxiF = -1000000000000.0;

          xp1 = yt;

          c_t = productionF(A_prod,xt)-yt;
          if ((c_use==1) && (i == 1)),
                c_t = c0;
          end
          
          for n = 1:max_coord,
           yp1 = y(n);
           if (yp1 < productionF(A_prod,xp1)),
              nval = (1-alpha_value)*utilityF(productionF(A_prod,xp1)-yp1,sigma) + alpha_value*utilityFdelta(productionF(A_prod,xp1)-yp1-c_t,phi) + beta_value * V(policy(i,2),n);
              if (nval > maxiF),
                optiy = n;
                maxiF = nval;
              end
           end
          end
          policy(i+1,:) = [optix optiy];
end
